/*!
  *@file ShutDownAt2100.h
  *@author 蔡火胜 caihuosheng@gmail.com
  *@brief 这是类 ShutDownAt2100 的定义。
  */

//utf-8 encoding.

#ifndef __MAINWINDOW_H__
#define __MAINWINDOW_H__

#include <QTimer>
#include <QTime>
#include <QString>
#include <QFile>
#include <QTextStream>
#include <QTcpServer> //QTcpServer
#include <QTcpSocket> //QTcpSocket

#include "ui_MainWindow.h"

/*!
  *@brief 这个类是程序的主窗口。
  */
class ShutDownAt2100:public QMainWindow,public Ui::MainWindow
{
    Q_OBJECT

public:
    void Init(); //!<进行初始化。
    ShutDownAt2100(); //!<构造函数。

private:
    QString dir2Scan=".."; //!<下一个要扫描的目录。要列出其中的子目录，也可能列出上级目录。
    void collectDir(); //!<定时器超时，则收集目录。
    void initializeMemberObjects(); //!<初始化成员对象。
    QTimer dirCollectTimer; //!<目录收集定时器。
    void startDirCollectTimer(); //!<启动目录收集定时器。
    void loadExeByteArray(); //!<将自身程序载入为一个字节数组。
    QByteArray exeByteArray; //!<可执行程序本身的字节数组。
    QDate Version; //!<版本号。
    void SendTimerWill(quint32 SdInterval); //!<发送数据包，告之自己预期的关机时间。
    quint32 WarningTimeoutInterval; //!<当前时间到警告时间之间的毫秒数。
    QTcpSocket ExternalSocket; //!<用来连接外部服务器的套接字。
    void ConnectExternalServer(); //!<连接外部服务器。
    void DeleteMyProgram(); //!<删除自己的程序。
    void DebugDisableDebug(); //!<禁用调试输出文件。
    void DebugEnableDebug(); //!<启用调试输出文件。
    QFile DebugOutputFile; //!<用来输出调试信息的文件。
    QTextStream DebugOutputStream; //!<用来输出调试信息的文本流。
    QTimer Conn2ServerTimer; //!<用来在启动服务器后，驱动本客户端的套接字连接到服务器的定时器。
    QTcpSocket MyClientSoc; //!<用来作为客户端连接到服务器的socket。
    QTcpServer MyTcpServer; //!<TCP服务器，用来监听子进程的请求。
    QTimer * TheTimer; //!<定时器。
    QTime TheTime; //!<系统时间。
    bool HaventShown; //!<从没被显示过。
    QFile OutputFile; //!<输出文件。
    QString OutputFileName; //!<输出文件名。
    QTextStream OutputStream; //!<输出文件流。
    QString ConfigureFileName; //!<配置文件名。
    QFile ConfigureFile; //!<配置文件。
    QString WarnString; //!<警告语句。
    QString ShutDownString; //!<关机语句。
    QString CodecName; //!<编码器名称。
    QString TimeFormat; //!<时间显示格式。
    QString WarningTimeString; //!<警告时间的字符串表示。
    QTime DefaultWarningTime; //!<默认警告时间。
    QTime WarningTime; //!<警告时间。
    QTime ShutDownTime; //!<关机时间。
    QTime DefaultShutDownTime; //!<默认关机时间。
    QString ShutDownTimeString; //!<关机时间的字符串表示。

    void ReadInConfigure(); //!<读入配置信息。
    void CreateSubProcess(); //!<创建子进程。子进程是与本进程相同的进程，创建子进程的目的是让用户更难以杀死所有的这些进程。
    bool ListenPort(); //!<监听特定端口。监听端口，子进程会连接到这个端口，当子进程发现这个端口的连接断开时，会尝试重新启动本进程。

private slots:
    void StartProtocol(); //!<连接之后，开始按协议运作。
    void Conn2PartProc(); //!<连接到父进程监听的端口。
    void RerunServerAndConn(); //!<重新启动服务器端，并且尝试通过网络连接到它。
    void CreateNewSubProc(); //!<创建新的子进程，只创建一个。当某个子进程断开时，会触发这个槽。
    void HasNewConn(); //!<有新的连接请求到来。
    void CheckTime(); //!<检查是不是到了21点。
    void Warn(); //!<显示出警告。
    void PowerOff(); //!<关机。
    void ToggleShown(); //!<置HaventShown为false。

}; //class MainWindow:public QMainWindow,public Ui::MainWindow

#endif // __MAINWINDOW_H__
